config/routes.rb
Everest::Application.routes.draw do
  resources :achievements

  resources :towers
  resources :sessions
  resources :users
  resources :climbs

  get "pages/index"

  get "register" => "users#new", :as => "register"
  get "login" => "users#login", :as => "login"
  get "logout" => "sessions#destroy"
  get "profile" => "users#profile"
  get "about" => "pages#about"

  match 'auth/:provider/callback', to: 'sessions#create_omniauth'
  match 'auth/failure', to: redirect('/')

  root :to => 'pages#index'

end

app/models/tower.rb
class Tower < ActiveRecord::Base
  extend FriendlyId
  attr_accessible :description, :name, :tag, :total_steps, :photo, :step_height
  friendly_id :tag
  has_attached_file :photo, :styles => { :large => "360x640", :small => "180x320" }
  
  validates :name, :presence => true
  validates :total_steps, :presence => true 
  validates :step_height, :presence => true 

  def pretty_steps
    # pretty print steps, with step included with value.
    return self.total_steps.to_s + " " +
      (self.total_steps == 1 ? "step" : "steps")
  end

  def pretty_step_height
    # pretty print step height
    return self.step_height.to_s + "m"
  end

  def height
    return self.total_steps * self.step_height
  end

  def pretty_height
    self.height.to_s + "m"
  end

end

app/controllers/towers_controller.rb
class TowersController < ApplicationController
  # GET /towers
  # GET /towers.json
  def index
    @towers = Tower.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @towers }
    end
  end

  # GET /towers/1
  # GET /towers/1.json
  def show
    logger.info "Tower id is #{params[:id]}"
    @tower = Tower.find(params[:id])
    @climbs = Climb.where(:tower_id => @tower.id)
    @floors = '[{"from": 1, "to": 2, "stepsPerFloor": 20}, {"from": 2, "to": 43, "stepsPerFloor": 20}]'

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @tower }
    end
  end

  # GET /towers/new
  # GET /towers/new.json
  def new
    if current_user and current_user.is_admin
        @tower = Tower.new

        respond_to do |format|
          format.html # new.html.erb
          format.json { render json: @tower }
        end
    else 
      redirect_to root_url
    end
  end

  # GET /towers/1/edit
  def edit
    if current_user and current_user.is_admin
      @tower = Tower.find(params[:id])
    else 
      redirect_to root_url
    end
  end

  # POST /towers
  # POST /towers.json
  def create
    if current_user and current_user.is_admin
        @tower = Tower.new(params[:tower])
        respond_to do |format|
          if @tower.save
            format.html { redirect_to @tower, notice: 'Tower was successfully created.' }
            format.json { render json: @tower, status: :created, location: @tower }
          else
            format.html { render action: "new" }
            format.json { render json: @tower.errors, status: :unprocessable_entity }
          end
        end
    else
      redirect_to root_url
    end
  end

  # PUT /towers/1
  # PUT /towers/1.json
  def update
    if current_user and current_user.is_admin
        @tower = Tower.find(params[:id])

        respond_to do |format|
          if @tower.update_attributes(params[:tower])
            format.html { redirect_to @tower, notice: 'Tower was successfully updated.' }
            format.json { head :no_content }
          else
            format.html { render action: "edit" }
            format.json { render json: @tower.errors, status: :unprocessable_entity }
          end
        end
    else
      redirect_to root_url
    end
  end

  # DELETE /towers/1
  # DELETE /towers/1.json
  def destroy
    if current_user and current_user.is_admin
        @tower = Tower.find(params[:id])
        @tower.destroy

        respond_to do |format|
          format.html { redirect_to towers_url }
          format.json { head :no_content }
        end
      end
    else
      redirect_to root_url
    end
end

app/helpers/towers_helper.rb
module TowersHelper
end

app/views/towers/_form.html.erb
<%= form_for @tower, :html => { :multipart => true } do |f| %>
  <% if @tower.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@tower.errors.count, "error") %> prohibited this tower from being saved:</h2>

      <ul>
      <% @tower.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :description %><br />
    <%= f.text_field :description %>
  </div>
  <div class="field">
    <%= f.label :total_steps %><br />
    <%= f.text_field :total_steps %>
  </div>
  <div class="field">
    <%= f.label :step_height %><br />
    <%= f.text_field :step_height %>
  </div>
  <div class="field">
    <%= f.label :tag %><br />
    <%= f.text_field :tag %>
  </div>
  <div class="field">
    <%= f.label :photo %>
    <%= f.file_field :photo %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/towers/_snippet.html.erb
<div class="tower-snippet">
  <h4><%= link_to tower.name, tower %></h4>
  <% if current_user %>
    <%= link_to 'Climb this tower', new_climb_path %>
  <% end %>
  <%= image_tag tower.photo.url(:small), :class => "tower-photo" %>
  <div class="clear"/>
</div>

app/views/towers/edit.html.erb
<h1>Editing tower</h1>

<%= render 'form' %>
<%= link_to 'Show', @tower %> |
<%= link_to 'Back', towers_path %>

app/views/towers/index.html.erb
<h1>Listing towers</h1>

<table>
  <tr>
    <th>Name</th>
    <th>Description</th>
    <th>Total steps</th>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @towers.each do |tower| %>
  <tr>
    <td><%= tower.name %></td>
    <td><%= tower.description %></td>
    <td><%= tower.total_steps %></td>
    <td><%= link_to 'Show', tower %></td>
    <td><%= link_to 'Edit', edit_tower_path(tower) %></td>
    <td><%= link_to 'Destroy', tower, method: :delete, data: { confirm: 'Are you sure?' } %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'New Tower', new_tower_path %>

app/views/towers/new.html.erb
<h1>New tower</h1>

<%= render 'form' %>
<%= link_to 'Back', towers_path %>

app/views/towers/show.html.erb
<p id="notice"><%= notice %></p>
<h1 class="name"><%= @tower.name %></h1>
<div class="tower-details">
<h2 class="steps"><%= @tower.pretty_height %> tall</h2>
<h2 class="steps"><%= @tower.pretty_steps %>, <%= @tower.pretty_step_height %> per step</h2>
<p class="description">
    <%= @tower.description %>
</p>
<% if current_user %>
  <%= link_to 'Climb this tower', new_climb_path %>
<% end %>
<h3>Recent climbs</h3>
<ul class="tower-climbs">
  <% @climbs.each do |climb| %>
    <li class="tower-climb">
      <% if climb.user.image %>
        <%= image_tag climb.user.image.url(:small), :class => "user-photo" %>
      <% end %>
      <%= link_to climb.user.username, climb.user %><br/> 
      climbed <%= climb.steps %> steps<br/> 
      on <%= pretty_time(climb.created_at) %>
      <div class="clear"/>
    </li>
  <% end %>
</ul>
<div id="stairs">
</div>
</div>
<%= image_tag @tower.photo.url(:large), :class => "tower-photo" %>
<!-- <%= link_to 'Edit', edit_tower_path(@tower) %> |
<%= link_to 'Back', towers_path %> -->